<?php

class Facebook extends Downloader
{
    private $cookies = '';

    public function fetch($videoUrl)
    {
        $host = parse_url($videoUrl, PHP_URL_HOST);
        if ($host === 'fb.watch') {
            $this->fetchFromApi($videoUrl);
            return;
        }
        preg_match('/https:\/\/www.facebook.com\/reel\/(\d*)/', $videoUrl, $match);
        if (!empty($match[1])) {
            $videoUrl = 'https://www.facebook.com/watch/?v=' . $match[1] . '&_rdr';
        }
        $this->cookies = get_option('aiodl_facebook_cookies');
        $http = new Http($videoUrl);
        $http->addHeader('cookie', $this->cookies);
        $http->addHeader('accept', 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.7');
        $http->addHeader('accept-encoding', 'identity');
        $http->addHeader('sec-fetch-mode', 'navigate');
        $http->run();
        $this->title = 'Facebook Video';
        $this->source = 'facebook';
        $this->thumbnail = 'https://cdn.nicheoffice.web.tr/image/49HW5RMnBg.webp';
        preg_match_all('/"browser_native_(hd|sd)_url":"(.*?)"/', $http->response, $match);
        for ($i = 0; ($i < count($match[0])) && $i < 2; ++$i) {
            $this->medias[] = new Media($this->jsonDecodeString($match[2][$i]), $match[1][$i], 'mp4', true, true);
        }
        preg_match('/"preferred_thumbnail":{"image":{"uri":"(.*?)"/', $http->response, $match);
        if (!empty($match[1])) {
            $this->thumbnail = $this->jsonDecodeString($match[1]);
        }
        preg_match('/"title":{"delight_ranges":\[.*?\],"image_ranges":\[.*?\],"inline_style_ranges":\[.*?\],"aggregated_ranges":\[.*?\],"ranges":\[.*?\],"color_ranges":\[.*?\],"text":"(.*?)"/', $http->response, $match);
        if (!empty($match[1])) {
            $this->title = $this->jsonDecodeString($match[1]);
            $this->title = Helpers::shortenText($this->title, 128);
        }
        if (empty($this->medias)) {
            $this->fetchFromApi($videoUrl);
        }
    }

    private function fetchFromApi($videoUrl)
    {
        $http = new Http('https://api.aiodown.com/v1/facebook/video?postUrl=' . urlencode($videoUrl));
        $http->run();
        $data = json_decode($http->response, true);
        if (empty($data['links']) || !$data['success']) {
            return;
        }
        $this->title = $data['title'];
        if ($this->title == 'Facebook') {
            $this->title = 'Facebook Video';
        }
        $this->source = 'facebook';
        $this->thumbnail = $data['thumbnail'];
        foreach ($data['links'] as $label => $url) {
            $quality = 'sd';
            if ($label == 'Download High Quality') {
                $quality = 'hd';
            }
            $this->medias[] = new Media($url, $quality, 'mp4', true, true);
        }
        usort($this->medias, array('Helpers', 'sortByQuality'));
    }

    private function jsonDecodeString($string)
    {
        $json = '{"str":"' . $string . '"}';
        return json_decode($json, true)['str'];
    }
}