<?php

class Substack extends Downloader
{
    public function fetch($videoUrl)
    {
        $http = new Http($videoUrl);
        $http->run();
        preg_match_all('/<script>window\._preloads\s*=\s*JSON\.parse\("(.*?)"\)<\/script>/', $http->response, $match);
        if (empty($match[1][0])) {
            return;
        }
        $data = json_decode(stripslashes($match[1][0]), true);
        if (empty($data['post'])) {
            return;
        }
        if ($data['post']['type'] !== 'video') {
            return;
        }
        $this->title = $data['post']['title'] ?? 'Substack Video';
        $this->source = 'substack';
        if (!empty($data['post']['cover_image'])) {
            $this->thumbnail = 'https://substackcdn.com/image/fetch/w_640,h_480,c_fill,f_webp,q_auto:good,fl_progressive:steep,g_center/' . $data['post']['cover_image'];
        } else {
            $this->thumbnail = 'https://cdn.nicheoffice.web.tr/image/dcHNqK8gi8.jpg';
        }
        $this->duration = (int)$data['post']['videoUpload']['duration'] ?? null;
        $http = new Http('https://api.aiodown.com/v1/substack/playlist?' . http_build_query([
                'videoID' => $data['post']['videoUpload']['id'],
                'host' => parse_url($videoUrl, PHP_URL_HOST),
            ]));
        $http->run();
        preg_match_all('/(https:.*)/', $http->response, $match);
        if (empty($match[0])) {
            return;
        }
        $chunks = $match[0];
        $cache = new Cache('substack-' . $data['post']['videoUpload']['id'], 'json', json_encode($chunks));
        $chunkSize = new Http($chunks[1]);
        $chunkSize = $chunkSize->getFileSize();
        $media = new Media($cache->url, 'hd', 'mp4', true, true);
        $media->size = $chunkSize * count($chunks);
        $media->chunked = true;
        $this->medias[] = $media;
    }
}