<?php

class Ted extends Downloader
{
    public function fetch($videoUrl)
    {
        $http = new Http($videoUrl);
        $http->run();
        $regex = $this->getRegex();
        preg_match_all($regex[0], $http->response, $match);
        if (empty($match[1][0])) {
            return;
        }
        $data = json_decode($match[1][0], true);
        if (empty($data['props']['pageProps']['videoData'])) {
            return;
        }
        $data = $data['props']['pageProps']['videoData'];
        $this->title = $data['title'];
        $this->source = 'ted';
        $this->thumbnail = $data['primaryImageSet'][0]['url'];
        $this->duration = $data['duration'];
        $playerData = json_decode($data['playerData'], true);
        if (empty($playerData['resources']['hls']['stream'])) {
            return;
        }
        $videoId = $playerData['id'];
        $playlistHost = explode('manifest.m3u8', $playerData['resources']['hls']['stream'])[0];
        $http = new Http($playerData['resources']['hls']['stream']);
        $http->run();
        preg_match_all($regex[1], $http->response, $match);
        $foundQualities = [];
        for ($i = 0; $i < count($match[1]); ++$i) {
            $q = explode('x', $match[1][$i]);
            if (!empty($foundQualities[$q[1]])) {
                continue;
            }
            $foundQualities[$q[1]] = $match[2][$i];
        }
        foreach ($foundQualities as $quality => $url) {
            $http = new Http($playlistHost . $url);
            $http->run();
            preg_match_all($regex[2], $http->response, $match);
            if (empty($match[1])) {
                continue;
            }
            $chunks = $match[1];
            $chunkSize = new Http($chunks[0]);
            $chunkSize = $chunkSize->getFileSize();
            $chunkFile = new Cache('ted-' . $videoId . '-' . $quality, 'json', json_encode($chunks));
            $media = new Media($chunkFile->url, $quality . 'p', 'mp4', true, true);
            $media->size = $chunkSize * count($chunks);
            $media->chunked = true;
            $this->medias[] = $media;
        }
        usort($this->medias, array('Helpers', 'sortByQuality'));
    }

    private function getRegex(){
        $http = new Http('https://api.aiodown.com/v1/ted/regex');
        $http->run();
        $data = json_decode($http->response, true);
        return $data['data'];
    }
}