<?php

class Threads extends Downloader
{
    public function fetch($videoUrl)
    {
        $data = $this->getPostDetailFromApi($videoUrl);
        if (!empty($data['data']['data']['containing_thread']['thread_items'])) {
            $data = $data['data']['data']['containing_thread']['thread_items'][0]['post'];
            $this->title = $data['caption']['text'] ?? 'Threads.net Video';
            $this->source = 'threads';
            $this->thumbnail = $data['image_versions2']['candidates'][0]['url'];
            $this->medias[] = new Media($this->thumbnail, 'hd', 'jpg', false, false);
            $this->encodeThumbnail();
            if (!empty($data['video_versions'])) {
                foreach ($data['video_versions'] as $video) {
                    $media = new Media($video['url'], 'hd', 'mp4', true, true);
                    $this->medias[] = $media;
                    break;
                }
            }
        }
    }

    private function getPostDetailFromApi($videoUrl)
    {
        $apiQuery = http_build_query([
            'postUrl' => $videoUrl,
        ]);
        $http = new Http('https://api.aiodown.com/v1/threads/post?' . $apiQuery);
        $http->run();
        return json_decode($http->response, true);
    }
}