<?php

class Tumblr extends Downloader
{
    public function fetch($videoUrl)
    {
        $urlDetails = $this->extractUrlDetails($videoUrl);
        if ($urlDetails == null) {
            return;
        }
        $data = $this->getVideoData($urlDetails['blog_name'], $urlDetails['post_id']);
        if (empty($data)) {
            return;
        }
        if (empty($data['response']['timeline']['elements'])) {
            return;
        }
        $data = $data['response']['timeline']['elements'][0];
        if (empty($data['video'])) {
            return;
        }
        $this->title = $data['summary'];
        $this->source = 'tumblr';
        $this->duration = $data['duration'];
        $this->thumbnail = $data['thumbnail_url'];
        $this->medias[] = new Media($data['video_url'], 'hd', 'mp4', true, true);
    }

    private function getApiKey()
    {
        $http = new Http('https://api.aiodown.com/v1/tumblr/api-key');
        $http->run();
        return $http->response;
    }

    private function getVideoData($blogName, $postId)
    {
        $http = new Http(sprintf('https://api-http2.tumblr.com/v2/blog/%s/posts/%s/permalink?api_key=%s', $blogName, $postId, $this->getApiKey()));
        $http->run();
        return json_decode($http->response, true);
    }

    private function extractUrlDetails($url)
    {
        $pattern = '/https?:\/\/([^.]+)\.tumblr\.com\/post\/(\d+)/';
        preg_match($pattern, $url, $matches);

        if (isset($matches[1]) && isset($matches[2])) {
            return [
                'blog_name' => $matches[1],
                'post_id' => $matches[2]
            ];
        } else {
            return null;
        }
    }
}