<?php

class Vimeo extends Downloader
{
    public function fetch($videoUrl)
    {
        $videoId = $this->getVideoId($videoUrl);
        if (empty($videoId)) {
            return;
        }
        $data = $this->getApiData($videoId, '');
        if (empty($data) || empty($data['files'])) {
            return;
        }
        $this->title = $data['name'];
        $this->source = 'vimeo';
        $this->thumbnail = reset($data['pictures']['sizes'])['link'];
        $this->duration = $data['duration'];
        foreach ($data['files'] as $video) {
            if ($video['rendition'][-1] != 'p') {
                continue;
            }
            $media = new Media($video['link'], $video['rendition'], 'mp4', true, true);
            $media->size = $video['size'];
            $this->medias[] = $media;
        }
        usort($this->medias, array('Helpers', 'sortByQuality'));
    }

    private function getVideoId($videoUrl)
    {
        preg_match_all('/(\d+)/', $videoUrl, $match);
        if (empty($match[0])) {
            return "";
        }
        return end($match[0]);
    }

    private function getApiHeaders()
    {
        $http = new Http('https://api.aiodown.com/v1/vimeo/headers');
        $http->run();
        return json_decode($http->response);
    }

    private function getApiData($videoId, $password)
    {
        if ($password != '') {
            $videoId .= $password;
        }
        $http = new Http('https://api.vimeo.com/videos/' . $videoId);
        $headers = $this->getApiHeaders();
        foreach ($headers as $header => $value) {
            $http->addHeader($header, $value);
        }
        $http->run();
        return json_decode($http->response, true);
    }
}