<?php

class Vkontakte extends Downloader
{
    public $userAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36';

    public function fetch($videoUrl)
    {
        $this->userAgent = Http::$userAgent;
        $this->source = 'vkontakte';
        preg_match('/[video|z=clip](-\d+_\d+)/', $videoUrl, $matches);
        if (!empty($matches[1])) {
            $this->downloadAl($matches[1]);
        }
        preg_match('/wall-\d+_\d+/', $videoUrl, $matches);
        if (!empty($matches)) {
            $this->downloadWall($matches[0]);
        }
    }

    private function downloadWall($videoId)
    {
        $payload = [
            'act' => 'show',
            'al' => '1',
            'w' => $videoId
        ];
        $page = $this->client('https://vk.com/wkview.php', 'POST', http_build_query($payload), [
            'Content-Type' => 'application/x-www-form-urlencoded',
            'X-Requested-With' => 'XMLHttpRequest',
        ]);
        preg_match('/video(\d+_\d+)\?list=(.*?)\\"/', $page, $matches);
        if (count($matches) < 3) {
            return;
        }
        $this->downloadAl($matches[1]);
    }

    private function downloadAl($videoId)
    {
        $payload = [
            'act' => 'show',
            'al' => '1',
            'video' => $videoId
        ];
        $page = $this->client('https://vk.com/al_video.php', 'POST', http_build_query($payload), [
            'Content-Type' => 'application/x-www-form-urlencoded',
            'X-Requested-With' => 'XMLHttpRequest',
            'Referer' => ' https://vk.com/al_video.php',
        ]);
        $data = json_decode($page, true, 512, JSON_INVALID_UTF8_IGNORE)['payload'][1][4]['player']['params'][0];
        if (empty($data['md_title'])) {
            return;
        }
        $this->title = $data['md_title'];
        if (!empty($data['jpg'])) {
            $this->thumbnail = $data['jpg'];
        } else if (!empty($data['first_frame_160'])) {
            $this->thumbnail = $data['first_frame_160'];
        }
        $this->duration = $data['duration'];
        $qualities = [['url240', '240p'], ['url360', '360p'], ['url480', '480p'], ['url720', '720p'], ['url1080', '1080p']];
        foreach ($qualities as $q) {
            if (empty($data[$q[0]])) {
                continue;
            }
            $this->addMedia($data[$q[0]], $q[1]);
        }
    }

    private function addMedia($url, $quality)
    {
        $media = new Media($url, $quality, 'mp4', true, true);
        $http = new Http($url);
        $http::$userAgent = $this->userAgent;
        $media->size = $http->getFileSize();
        if ($media->size < 100) {
            return;
        }
        $this->medias[] = $media;
    }

    private function client($url, $method = 'GET', $payload = '', $headers = [])
    {
        $http = new Http($url);
        $http->addCurlOption(CURLOPT_CUSTOMREQUEST, $method);
        if (!empty($headers)) {
            foreach ($headers as $key => $value) {
                $http->addHeader($key, $value);
            }
        } else {
            $http->addHeader('Cookie', 'remixlang=3; remixstlid=9093584503576001439_Vhk8nzG7kj5Yx9vWrbmZLvKTJ97vZis4zsDhNE3I7iL; remixua=-1%7C-1%7C202%7C379917791');
        }
        if (!empty($payload)) {
            $http->addCurlOption(CURLOPT_POSTFIELDS, $payload);
        }
        $http->run();
        return $http->response;
    }
}