<?php

class Bitchute extends Downloader
{
    public function fetch($videoUrl)
    {
        $videoId = $this->getVideoId($videoUrl);
        if (empty($videoId)) {
            return;
        }
        $videoInfo = $this->getVideoInfo($videoId);
        if (empty($videoInfo)) {
            return;
        }
        $this->title = $videoInfo['video_name'];
        $this->source = 'bitchute';
        $this->thumbnail = $videoInfo['thumbnail_url'];
        $videoMedia = $this->getVideoMedia($videoId);
        if (empty($videoMedia)) {
            return;
        }
        $this->medias[] = new Media($videoMedia['media_url'], 'hd', 'mp4', true, true);
    }

    private function getVideoId($videoUrl)
    {
        preg_match('/video\/(\w*)/', $videoUrl, $match);
        return !empty($match[1]) ? $match[1] : '';
    }

    private function getVideoInfo($videoId)
    {
        $http = new Http('https://api.bitchute.com/api/beta9/video');
        $http->addCurlOption(CURLOPT_CUSTOMREQUEST, 'POST');
        $http->addCurlOption(CURLOPT_POSTFIELDS, json_encode(['video_id' => $videoId]));
        $http->addHeader('Content-Type', 'application/json');
        $http->run();
        return json_decode($http->response, true);
    }

    private function getVideoMedia($videoId)
    {
        $http = new Http('https://api.bitchute.com/api/beta/video/media');
        $http->addCurlOption(CURLOPT_CUSTOMREQUEST, 'POST');
        $http->addCurlOption(CURLOPT_POSTFIELDS, json_encode(['video_id' => $videoId]));
        $http->addHeader('Content-Type', 'application/json');
        $http->run();
        return json_decode($http->response, true);
    }

}