<?php

class Dailymotion extends Downloader
{

    public function fetch($videoUrl)
    {
        $videoId = $this->extractVideoId($videoUrl);
        $http = new Http('https://api.aiodown.com/v1/dailymotion/video/' . $videoId);
        $http->run();
        if (empty($http->response)) {
            return;
        }
        $data = json_decode($http->response, true);
        $this->title = $data['title'];
        $this->source = 'dailymotion';
        $this->thumbnail = end($data['thumbnails']);
        $this->duration = $data['duration'];
        $streamsM3u8 = new Http($data['qualities']['auto'][0]['url']);
        $streamsM3u8->run();
        $streamsM3u8 = $streamsM3u8->response;
        preg_match_all('/#EXT-X-STREAM-INF:(.*)/', $streamsM3u8, $streamsRaw);
        $streamsRaw = $streamsRaw[1];
        $streams = array();
        foreach ($streamsRaw as $stream) {
            $quality = Helpers::getStringBetween($stream, 'NAME="', '"');
            if (!isset($streams[$quality])) {
                $streams[$quality]['quality'] = $quality;
                $streams[$quality]['url'] = Helpers::getStringBetween($stream, 'PROGRESSIVE-URI="', '"');
            }
        }
        foreach ($streams as $stream) {
            $this->medias[] = new Media($stream['url'], $stream['quality'] . 'p', 'mp4', true, true);
        }
        usort($this->medias, array('Helpers', 'sortByQuality'));
    }

    private function extractVideoId($url)
    {
        $domain = str_ireplace('www.', '', parse_url($url, PHP_URL_HOST));
        switch (true) {
            case($domain == 'dai.ly'):
                $videoId = str_replace('https://dai.ly/', "", $url);
                $videoId = str_replace('/', "", $videoId);
                return $videoId;
            case($domain == 'dailymotion.com'):
                $urlParts = parse_url($url);
                $pathArr = explode('/', $urlParts['path']);
                $videoId = $pathArr[2];
                if ($videoId == 'video' && count($pathArr) === 4) {
                    $videoId = $pathArr[3];
                }
                return $videoId;
            default:
                return '';
        }
    }
}