<?php

class LinkedIn extends Downloader
{
    public function fetch($videoUrl)
    {
        $cookies = get_option('aiodl_linkedin_cookies');
        $http = new Http($videoUrl);
        $http->addHeader('cookie', $cookies);
        $http->run();
        $data = Helpers::getStringBetween($http->response, 'data-sources="', '"');
        if ($data == '') {
            $this->parsePrivateVideo($http->response);
            return;
        }
        $this->title = Helpers::getStringBetween($http->response, '<title>', '</title>');
        $this->source = 'linkedin';
        $this->thumbnail = html_entity_decode(Helpers::getStringBetween($http->response, 'data-poster-url="', '"'));
        $videoUrl = json_decode(html_entity_decode($data), true)[0]['src'];
        if ($videoUrl != '') {
            $this->medias[] = new Media($videoUrl, 'hd', 'mp4', true, true);
            $http = new Http($videoUrl);
            $headers = $http->getHeaders();
            if (!empty($headers['Content-Length'])) {
                $this->medias[0]->size = $headers['Content-Length'];
            }
        }
    }

    private function parsePrivateVideo($page)
    {
        preg_match_all('/<code[^>]*>(.*?)<\/code>/s', $page, $matches);
        $data = null;
        foreach ($matches[1] as $match) {
            $data = json_decode(html_entity_decode($match), true);
            if (!empty($data['included'][0]['progressiveStreams'])) {
                break;
            }
        }
        if (empty($data['included'][0]['progressiveStreams'])) {
            return;
        }
        $data = $data['included'][0];
        $this->title = 'LinkedIn Video';
        $this->source = 'linkedin';
        $this->duration = (int)$data['duration'] / 1000;
        $this->thumbnail = $data['thumbnail']['rootUrl'] . $data['thumbnail']['artifacts'][0]['fileIdentifyingUrlPathSegment'];
        foreach ($data['progressiveStreams'] as $stream) {
            $this->medias[] = new Media($stream['streamingLocations'][0]['url'], $stream['width'] . 'p', 'mp4', true, true);
        }
    }
}