<?php

class Loom extends Downloader
{
    public function fetch($videoUrl)
    {
        preg_match('/share\/(\w*)/', $videoUrl, $match);
        if (count($match) < 2) {
            return;
        }
        $sessionId = $match[1];
        $http = new Http($videoUrl);
        $http->run();
        preg_match_all('/window.loomSSRVideo = (.*);/', $http->response, $match);
        if (count($match) < 2) {
            return;
        }
        $data = json_decode($match[1][0], true);
        $this->title = $data['name'] ?? 'Loom Video';
        if (!empty($data['defaultThumbnails']['default'])) {
            $this->thumbnail = 'https://cdn.loom.com/' . $data['defaultThumbnails']['default'];
        }
        $this->duration = (int)$data['playable_duration'] ?? null;
        $this->source = 'loom';
        $this->medias[] = new Media($this->getTranscodedUrl($sessionId), 'hd', 'mp4', true, true);
    }

    private function getTranscodedUrl($sessionId)
    {
        $http = new Http('https://api.aiodown.com/v1/loom/sessions/' . $sessionId);
        $http->addCurlOption(CURLOPT_CUSTOMREQUEST, 'POST');
        $http->run();
        $data = json_decode($http->response, true);
        if (empty($data['url'])) {
            return null;
        }
        return $data['url'];
    }
}