<?php

class Odnoklassniki extends Downloader
{
    public function fetch($videoUrl)
    {
        preg_match('/video\/(\d*)/', $videoUrl, $match);
        if (empty($match[1])) {
            return;
        }
        $videoId = $match[1];
        $data = $this->getVideoData($videoId);
        if (empty($data)) {
            return;
        }
        $this->title = $data['movie']['title'];
        $this->source = 'odnoklassniki';
        $this->thumbnail = $data['movie']['poster'];
        $this->duration = $data['movie']['duration'];
        foreach ($data['videos'] as $video) {
            $this->medias[] = new Media($video['url'], $video['name'], 'mp4', true, true);
        }
    }

    private function getVideoData($videoId)
    {
        $http = new Http('https://api.aiodown.com/v1/odnoklassniki/video/' . $videoId);
        $http->addCurlOption(CURLOPT_CUSTOMREQUEST, 'POST');
        $http->run();
        return json_decode($http->response, true);
    }
}