<?php

class Snapchat extends Downloader
{
    private $cookies = '';

    public function fetch($videoUrl)
    {
        $this->cookies = get_option('aiodl_snapchat_cookies');
        $http = new Http($videoUrl);
        $http->addHeader('cookie', $this->cookies);
        $http->run();
        $regex = $this->getRegex();
        preg_match_all($regex[0], $http->response, $matches);
        if (!empty($matches[1][0])) {
            $data = json_decode($matches[1][0], true);
            if (!empty($data['props']['pageProps']['preselectedStory']['premiumStory']['playerStory']['snapList'])) {
                $data = $data['props']['pageProps']['preselectedStory']['premiumStory']['playerStory'];
                $this->title = $data['storyTitle']['value'];
                $this->source = 'snapchat';
                $this->thumbnail = $data['thumbnailUrl']['value'];
                $this->medias[] = new Media($data['snapList'][0]['snapUrls']['mediaUrl'], 'hd', 'mp4', true, true);
            } else if (!empty($data['props']['pageProps']['spotlightFeed']['spotlightStories'])) {
                $story = $data['props']['pageProps']['spotlightFeed']['spotlightStories'][0];
                $this->title = $story['metadata']['videoMetadata']['name'];
                $this->source = 'snapchat';
                $this->thumbnail = $story['metadata']['videoMetadata']['thumbnailUrl'];
                $this->medias[] = new Media($story['story']['snapList'][0]['snapUrls']['mediaUrl'], 'hd', 'mp4', true, true);
            } else if (!empty($data['props']['pageProps']['story']['snapList'])) {
                $stories = $data['props']['pageProps']['story']['snapList'];
                $this->title = $data['props']['pageProps']['pageMetadata']['pageTitle'];
                $this->source = 'snapchat';
                $this->thumbnail = $data['props']['pageProps']['linkPreview']['twitterImage']['url'];
                foreach ($stories as $story) {
                    $type = $story['snapMediaType'] === 0 ? 'jpg' : 'mp4';
                    $this->medias[] = new Media($story['snapUrls']['mediaUrl'], 'hd', $type, true, true);
                }
            }
            if (!empty($this->medias) && strpos($this->medias[0]->url, "m3u8") !== false) {
                $originalPlaylist = $this->medias[0]->url;
                $this->medias = [];
                $http = new Http($originalPlaylist);
                $http->run();
                preg_match_all($regex[1], $http->response, $qualities);
                if (!empty($qualities) && count($qualities) == 3) {
                    for ($i = 0; $i < count($qualities[2]); ++$i) {
                        $playlistUrl = preg_replace('/\/d\/(.*?.m3u8)/', '/d/' . $qualities[2][$i], $originalPlaylist);
                        $http = new Http($playlistUrl);
                        $http->run();
                        preg_match_all('/(.*?mp4)\s/', $http->response, $parts);
                        if (!empty($parts)) {
                            $mediaUrl = preg_replace('/\/d\/(.*?.m3u8)/', '/d/' . trim($parts[0][0]), $originalPlaylist);
                            $this->medias[] = new Media($mediaUrl, $qualities[1][$i] . 'p', 'mp4', true, true);
                        }
                    }
                }

            }
        }
    }

    private function getRegex(){
        $http = new Http('https://api.aiodown.com/v1/snapchat/regex');
        $http->run();
        $data = json_decode($http->response, true);
        return $data['data'];
    }
}