<?php

class Twitter extends Downloader
{
    private $authToken = 'Bearer AAAAAAAAAAAAAAAAAAAAANRILgAAAAAAnNwIzUejRCOuH5E6I8xnZz4puTs%3D1Zv7ttfk8LF81IUq16cHjhLTvJu4FA33AGWWjCpTnA';

    public function fetch($videoUrl)
    {
        $this->fetchGraphQL($videoUrl);
        if (empty($this->medias) || empty($this->thumbnail)) {
            $this->fetchSyndication($videoUrl);
        }
        $this->encodeThumbnail();
    }

    public function fetchSyndication($videoUrl)
    {
        $videoUrl = strtok($videoUrl, '?');
        $tweetId = $this->extractVideoId($videoUrl);
        $http = new Http(sprintf('https://cdn.syndication.twimg.com/tweet-result?id=%s&token=%s', $tweetId, $this->generateSyndicationToken()));
        $http->run();
        $data = json_decode($http->response, true);
        if (empty($data['video'])) {
            return;
        }
        $this->title = $this->cleanTitle($data['text']) ?? 'Twitter Video';
        $this->source = 'twitter';
        $this->duration = $data['video']['durationMs'] / 1000;
        $this->thumbnail = $data['video']['poster'] ?? null;
        foreach ($data['video']['variants'] as $video) {
            if ($video['type'] == 'video/mp4') {
                $this->medias[] = new Media($video['src'], $this->getQuality($video['src']), 'mp4', true, true);
            }
        }
        usort($this->medias, array('Helpers', 'sortByQuality'));
    }

    public function fetchGraphQL($videoUrl)
    {
        $videoUrl = strtok($videoUrl, '?');
        $tweetId = $this->extractVideoId($videoUrl);
        if (empty($tweetId)) {
            return;
        }
        $http = new Http('https://api.twitter.com/1.1/guest/activate.json');
        $http->addCurlOption(CURLOPT_CUSTOMREQUEST, 'POST');
        $http->addHeader('Authorization', $this->authToken);
        $http->run();
        $data = json_decode($http->response, true);
        $guestToken = $data['guest_token'] ?? null;
        if ($guestToken === null) {
            return;
        }
        $http = new Http('https://twitter.com/i/api/graphql/2ICDjqPd81tulZcYrtpTuQ/TweetResultByRestId?variables=%7B%22tweetId%22%3A%22' . $tweetId . '%22%2C%22withCommunity%22%3Afalse%2C%22includePromotedContent%22%3Afalse%2C%22withVoice%22%3Afalse%7D&features=%7B%22creator_subscriptions_tweet_preview_api_enabled%22%3Atrue%2C%22tweetypie_unmention_optimization_enabled%22%3Atrue%2C%22responsive_web_edit_tweet_api_enabled%22%3Atrue%2C%22graphql_is_translatable_rweb_tweet_is_translatable_enabled%22%3Atrue%2C%22view_counts_everywhere_api_enabled%22%3Atrue%2C%22longform_notetweets_consumption_enabled%22%3Atrue%2C%22responsive_web_twitter_article_tweet_consumption_enabled%22%3Afalse%2C%22tweet_awards_web_tipping_enabled%22%3Afalse%2C%22freedom_of_speech_not_reach_fetch_enabled%22%3Atrue%2C%22standardized_nudges_misinfo%22%3Atrue%2C%22tweet_with_visibility_results_prefer_gql_limited_actions_policy_enabled%22%3Atrue%2C%22longform_notetweets_rich_text_read_enabled%22%3Atrue%2C%22longform_notetweets_inline_media_enabled%22%3Atrue%2C%22responsive_web_graphql_exclude_directive_enabled%22%3Atrue%2C%22verified_phone_label_enabled%22%3Afalse%2C%22responsive_web_media_download_video_enabled%22%3Afalse%2C%22responsive_web_graphql_skip_user_profile_image_extensions_enabled%22%3Afalse%2C%22responsive_web_graphql_timeline_navigation_enabled%22%3Atrue%2C%22responsive_web_enhance_cards_enabled%22%3Afalse%7D&fieldToggles=%7B%22withArticleRichContentState%22%3Afalse%7D');
        $http->addHeader('Authorization', $this->authToken);
        $http->addHeader('X-Guest-Token', $guestToken);
        $http->run();
        $data = json_decode($http->response, true);
        if (empty($data['data']['tweetResult']['result']['legacy'])) {
            return;
        }
        $data = $data['data']['tweetResult']['result']['legacy'];
        if (empty($data['extended_entities']['media'])) {
            return;
        }
        $this->title = $this->cleanTitle($data['full_text']) ?? 'Twitter Video';
        $this->source = 'twitter';
        $this->duration = $data['extended_entities']['media'][0]['video_info']['duration_millis'] / 1000;
        $this->thumbnail = $data['extended_entities']['media'][0]['media_url_https'] ?? null;
        foreach ($data['extended_entities']['media'][0]['video_info']['variants'] as $video) {
            if ($video['content_type'] == 'video/mp4') {
                $this->medias[] = new Media($video['url'], $this->getQuality($video['url']), 'mp4', true, true);
            }
        }
        usort($this->medias, array('Helpers', 'sortByQuality'));
    }

    public function fetch2($videoUrl)
    {
        $videoUrl = strtok($videoUrl, '?');
        $tweetId = $this->extractVideoId($videoUrl);
        if (!empty($tweetId)) {
            $http = new Http('https://api.aiodown.com/v1/twitter/tweet/' . $tweetId);
            $http->run();
            $data = json_decode($http->response, true);
            if (!empty($data['video'])) {
                $this->title = $this->cleanTitle($data['text']) ?? 'Twitter Video';
                $this->source = 'twitter';
                $this->duration = $data['video']['durationMs'] / 1000;
                $this->thumbnail = $data['video']['poster'] ?? null;
                foreach ($data['video']['variants'] as $video) {
                    if ($video['type'] == 'video/mp4') {
                        $this->medias[] = new Media($video['src'], $this->getQuality($video['src']), 'mp4', true, true);
                    }
                }
                usort($this->medias, array('Helpers', 'sortByQuality'));
            }
        }
    }

    private function generateSyndicationToken($length = 10)
    {
        $characters = '123456789abcdefghijklmnopqrstuvwxyz';
        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $randomString;
    }

    private function cleanTitle($title)
    {
        $pos = strpos($title, 'https://t.co');
        if ($pos !== false) {
            $title = substr($title, 0, $pos);
        }
        return !empty($title) ? $title : 'Twitter Video';
    }

    private function extractVideoId($videoUrl)
    {
        $last_char = substr($videoUrl, -1);
        if ($last_char == '/') {
            $videoUrl = substr($videoUrl, 0, -1);
        }
        $arr = explode('/', $videoUrl);
        return end($arr);
    }

    private function getQuality($url)
    {
        preg_match_all('/vid\/(.*?)x(.*?)\//', $url, $output);
        if (!empty($output[2][0])) {
            return $output[2][0] . 'p';
        } else {
            return 'gif';
        }
    }
}