<?php
require_once __DIR__ . '/../Shortener.php';
require_once __DIR__ . '/../Http.php';

class Shrtfly extends Shortener
{
    public static $API_URL = 'https://shrtfly.com/api';
    public static $NAME = 'shrtfly.com';
    private static $debug = false;

    public function shorten($url)
    {
        $this->API_KEY = get_option('aiodl_shrtfly_api_key');
        if (self::$debug) {
            $url = str_replace('localhost', 'example.com', $url);
        }
        $endpoint = sprintf('%s?api=%s&url=%s&format=text&type=1', self::$API_URL, $this->API_KEY, $url);
        $http = new Http($endpoint);
        $http->run();
        if (!empty($http->response) && filter_var($http->response, FILTER_VALIDATE_URL)) {
            return $http->response;
        }
        return null;
    }
}